# basic_streambuf Class Template Reference

Inheritance diagram for basic_streambuf:

List of all members.

## Detailed Description

### template<typename _CharT, typename _Traits>
class std::basic_streambuf< _CharT, _Traits >

This is a base class. Derived stream buffers each control a pair of character sequences: one for input, and one for output.

Section [27.5.1] of the standard describes the requirements and behavior of stream buffer classes. That section (three paragraphs) is reproduced here, for simplicity and accuracy.

1. Stream buffers can impose various constraints on the sequences they control. Some constraints are:
   - The controlled input sequence can be not readable.
   - The controlled output sequence can be not writable.
   - The controlled sequences can be associated with the contents of other representations for character sequences, such as external files.
   - The controlled sequences can support operations directly to or from associated sequences.
   - The controlled sequences can impose limitations on how the program can read characters from a sequence, write characters to a sequence, put characters back into an input sequence, or alter the stream position.
2. Each sequence is characterized by three pointers which, if non-null, all point into the same `charT` array object. The array object represents, at any moment, a (sub)sequence of characters from the sequence. Operations performed on a sequence alter the values stored in these pointers, perform reads and writes directly to or from associated sequences, and alter "the stream position" and conversion state as needed to maintain this subsequence relationship. The three pointers are:
   - the beginning pointer, or lowest element address in the array (called xbeg here);
   - the next pointer, or next element address that is a current candidate for reading or writing (called xnext here);
   - the end pointer, or first element address beyond the end of the array (called xend here).
3. The following semantic constraints shall always apply for any set of three pointers for a sequence, using the pointer names given immediately above:
   - If xnext is not a null pointer, then xbeg and xend shall also be non-null pointers into the same `charT` array, as described above; otherwise, xbeg and xend shall also be null.
   - If xnext is not a null pointer and xnext < xend for an output sequence, then a write position is available. In this case, *xnext shall be assignable as the next element to write (to put, or to store a character value, into the sequence).
   - If xnext is not a null pointer and xbeg < xnext for an input sequence, then a putback position is available. In this case, xnext[-1] shall have a defined value and is the next (preceding) element to store a character that is put back into the input sequence.
   - If xnext is not a null pointer and xnext< xend for an input sequence, then a read position is available. In this case, *xnext shall have a defined value and is the next element to read (to get, or to obtain a character value, from the sequence).

Definition at line 122 of file streambuf.

## Public Types

- typedef basic_streambuf< char_type,
  traits_type > __streambuf_type
- typedef _CharT char_type
- typedef traits_type::int_type int_type
- typedef traits_type::off_type off_type
- typedef traits_type::pos_type pos_type
- typedef _Traits traits_type

## Public Member Functions

- locale getloc () const
- streamsize in_avail ()
- locale pubimbue (const locale &__loc)
- pos_type pubseekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
- pos_type pubseekpos (pos_type __sp, ios_base::openmode __mode=ios_base::in|ios_base::out)
- __streambuf_type * pubsetbuf (char_type *__s, streamsize __n)
- int pubsync ()
- int_type sbumpc ()
- int_type sgetc ()
- streamsize sgetn (char_type *__s, streamsize __n)
- int_type snextc ()
- int_type sputbackc (char_type __c)
- int_type sputc (char_type __c)
- streamsize sputn (const char_type *__s, streamsize __n)
- void stossc ()
- int_type sungetc ()
- virtual ~basic_streambuf ()

## Protected Member Functions

- basic_streambuf ()
- char_type * eback () const
- char_type * egptr () const
- char_type * epptr () const
- void gbump (int __n)
- char_type * gptr () const
- virtual void imbue (const locale &)
- virtual int_type overflow (int_type=traits_type::eof())
- virtual int_type pbackfail (int_type=traits_type::eof())
- char_type * pbase () const
- void pbump (int __n)
- char_type * pptr () const
- virtual pos_type seekoff (off_type, ios_base::seekdir, ios_base::openmode=ios_base::in|ios_base::out)
- virtual pos_type seekpos (pos_type, ios_base::openmode=ios_base::in|ios_base::out)
- virtual basic_streambuf< char_type,
  _Traits > * setbuf (char_type *, streamsize)
- void setg (char_type *__gbeg, char_type *__gnext, char_type *__gend)
- void setp (char_type *__pbeg, char_type *__pend)
- virtual streamsize showmanyc ()
- virtual int sync ()
- virtual int_type uflow ()
- virtual int_type underflow ()
- virtual streamsize xsgetn (char_type *__s, streamsize __n)
- virtual streamsize xsputn (const char_type *__s, streamsize __n)

## Protected Attributes

- locale _M_buf_locale
- char_type * _M_in_beg
- char_type * _M_in_cur
- char_type * _M_in_end
- char_type * _M_out_beg
- char_type * _M_out_cur
- char_type * _M_out_end

## Friends

- streamsize __copy_streambufs (__streambuf_type *__sbin, __streambuf_type *__sbout)
- class basic_ios< char_type, traits_type >
- class basic_istream< char_type, traits_type >
- class basic_ostream< char_type, traits_type >
- template<typename _CharT2, typename _Traits2, typename _Alloc> basic_istream< _CharT2, _Traits2 > & getline (basic_istream< _CharT2, _Traits2 > &, basic_string< _CharT2, _Traits2, _Alloc > &, _CharT2)
- class istreambuf_iterator< char_type, traits_type >
- class ostreambuf_iterator< char_type, traits_type >

## Member Typedef Documentation

typedef _CharT char_type

| These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation. Reimplemented in stdio_filebuf, stdio_sync_filebuf, basic_filebuf, basic_stringbuf, and basic_filebuf< char_type, traits_type >. Definition at line 131 of file streambuf.

## Constructor & Destructor Documentation

virtual ~basic_streambuf | ( |  | ) | `[inline, virtual]`

| Destructor deallocates no buffer space. Definition at line 190 of file streambuf.

basic_streambuf | ( |  | ) | `[inline, protected]`

Base constructor.

Only called from derived constructors, and sets up all the buffer data to zero, including the pointers described in the basic_streambuf class description. Note that, as a result,

- the class starts with no read nor write positions available,
- this is not an error

Definition at line 437 of file streambuf.

## Member Function Documentation

char_type* eback | ( |  | ) | const`[inline, protected]`

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 456 of file streambuf.

Referenced by basic_filebuf::imbue(), basic_stringbuf::overflow(), basic_stringbuf::seekoff(), basic_filebuf::seekoff(), basic_stringbuf::seekpos(), basic_streambuf< char_type, traits_type >::sputbackc(), and basic_filebuf::underflow().

void gbump | ( | int | __n | ) | `[inline, protected]`

Moving the read position.

Parameters:

  | n | The delta by which to move.

This just advances the read position without returning any data.

Definition at line 472 of file streambuf.

Referenced by basic_stringbuf::pbackfail(), basic_filebuf::pbackfail(), basic_streambuf< char_type, traits_type >::sbumpc(), basic_stringbuf::seekoff(), basic_stringbuf::seekpos(), basic_streambuf< char_type, traits_type >::sputbackc(), basic_streambuf< char_type, traits_type >::stossc(), basic_streambuf< char_type, traits_type >::sungetc(), basic_streambuf< char_type, traits_type >::uflow(), and basic_streambuf::xsgetn().

locale getloc | ( |  | ) | const`[inline]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 219 of file streambuf.

virtual void imbue | ( | const locale & |  | ) | `[inline, protected, virtual]`

Changes translations.

Parameters:

  | loc | A new locale.

Translations done during I/O which depend on the current locale are changed by this call. The standard adds, "Between invocations of this function a class derived from streambuf can safely cache results of calls to locale functions and to members of facets so obtained."

Note:
  Base class version does nothing.

Reimplemented in basic_filebuf, and basic_filebuf< char_type, traits_type >.

Definition at line 550 of file streambuf.

Referenced by basic_streambuf< char_type, traits_type >::pubimbue().

streamsize in_avail | ( |  | ) | `[inline]`

Looking ahead into the stream.

Returns:
  The number of characters available.

If a read position is available, returns the number of characters available for reading before the buffer must be refilled. Otherwise returns the derived `showmanyc()`.

Definition at line 259 of file streambuf.

virtual int_type overflow | ( | int_type | = `traits_type::eof()` | ) | `[inline, protected, virtual]`

Consumes data from the buffer; writes to the controlled sequence.

Parameters:

  | c | An additional character to consume.

Returns:
  eof() to indicate failure, something else (usually c, or not_eof())

Informally, this function is called when the output buffer is full (or does not exist, as buffering need not actually be done). If a buffer exists, it is "consumed", with "some effect" on the controlled sequence. (Typically, the buffer is written out to the sequence verbatim.) In either case, the character c is also written out, if c is not `eof()`.

For a formal definiton of this function, see a good text such as Langer & Kreft, or [27.5.2.4.5]/3-7.

A functioning output streambuf can be created by overriding only this function (no buffer area will be used).

Note:
  Base class version does nothing, returns eof().

Reimplemented in stdio_sync_filebuf, basic_filebuf, basic_stringbuf, and basic_filebuf< char_type, traits_type >.

Definition at line 741 of file streambuf.

Referenced by basic_streambuf< char_type, traits_type >::sputc(), and basic_streambuf::xsputn().

virtual int_type pbackfail | ( | int_type | = `traits_type::eof()` | ) | `[inline, protected, virtual]`

Tries to back up the input sequence.

Parameters:

  | c | The character to be inserted back into the sequence.

Returns:
  eof() on failure, "some other value" on success

Postcondition:
  The constraints of `gptr()`, `eback()`, and `pptr()` are the same as for `underflow()`.

Note:
  Base class version does nothing, returns eof().

Reimplemented in stdio_sync_filebuf, basic_filebuf, basic_stringbuf, and basic_filebuf< char_type, traits_type >.

Definition at line 698 of file streambuf.

Referenced by basic_streambuf< char_type, traits_type >::sputbackc(), and basic_streambuf< char_type, traits_type >::sungetc().

char_type* pbase | ( |  | ) | const`[inline, protected]`

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 503 of file streambuf.

Referenced by basic_stringbuf::overflow(), basic_filebuf::overflow(), basic_stringbuf::seekoff(), and basic_stringbuf::seekpos().

void pbump | ( | int | __n | ) | `[inline, protected]`

Moving the write position.

Parameters:

  | n | The delta by which to move.

This just advances the write position without returning any data.

Definition at line 519 of file streambuf.

Referenced by basic_filebuf::overflow(), basic_stringbuf::seekoff(), basic_stringbuf::seekpos(), basic_streambuf< char_type, traits_type >::sputc(), and basic_streambuf::xsputn().

locale pubimbue | ( | const locale & | __loc | ) | `[inline]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 202 of file streambuf.

__streambuf_type* pubsetbuf | ( | char_type * | __s,
|  | streamsize | __n
| ) | `[inline]`

| Entry points for derived buffer functions. The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged. Definition at line 232 of file streambuf.

int_type sbumpc | ( |  | ) | `[inline]`

Getting the next character.

Returns:
  The next character, or eof.

If the input read position is available, returns that character and increments the read pointer, otherwise calls and returns `uflow()`.

Definition at line 291 of file streambuf.

Referenced by basic_istream::getline(), basic_istream::ignore(), istreambuf_iterator::operator++(), and std::operator>>().

virtual pos_type seekoff | ( | off_type | ,
|  | ios_base::seekdir | ,
|  | ios_base::openmode | = `ios_base::in | ios_base::out`
| ) | `[inline, protected, virtual]`

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note:
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented in basic_filebuf, basic_stringbuf, and basic_filebuf< char_type, traits_type >.

Definition at line 576 of file streambuf.

virtual pos_type seekpos | ( | pos_type | ,
|  | ios_base::openmode | = `ios_base::in | ios_base::out`
| ) | `[inline, protected, virtual]`

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note:
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented in basic_filebuf, basic_stringbuf, and basic_filebuf< char_type, traits_type >.

Definition at line 588 of file streambuf.

virtual basic_streambuf<char_type,_Traits>* setbuf | ( | char_type * | ,
|  | streamsize |
| ) | `[inline, protected, virtual]`

Maniuplates the buffer.

Each derived class provides its own appropriate behavior. See the next-to-last paragraph of http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#2 for more on this function.

Note:
  Base class version does nothing, returns `this`.

Reimplemented in basic_filebuf, basic_stringbuf, and basic_filebuf< char_type, traits_type >.

Definition at line 565 of file streambuf.

Referenced by basic_streambuf< char_type, traits_type >::pubsetbuf().

void setg | ( | char_type * | __gbeg,
|  | char_type * | __gnext,
|  | char_type * | __gend
| ) | `[inline, protected]`

Setting the three read area pointers.

Parameters:

  | gbeg | A pointer.
  | gnext | A pointer.
  | gend | A pointer.

Postcondition:
  gbeg == `eback()`, gnext == `gptr()`, and gend == `egptr()`

Definition at line 483 of file streambuf.

void setp | ( | char_type * | __pbeg,
|  | char_type * | __pend
| ) | `[inline, protected]`

Setting the three write area pointers.

Parameters:

  | pbeg | A pointer.
  | pend | A pointer.

Postcondition:
  pbeg == `pbase()`, pbeg == `pptr()`, and pend == `epptr()`

Definition at line 529 of file streambuf.

int_type sgetc | ( |  | ) | `[inline]`

Getting the next character.

Returns:
  The next character, or eof.

If the input read position is available, returns that character, otherwise calls and returns `underflow()`. Does not move the read position after fetching the character.

Definition at line 313 of file streambuf.

Referenced by basic_istream::get(), basic_istream::getline(), basic_istream::ignore(), and basic_streambuf< char_type, traits_type >::snextc().

streamsize sgetn | ( | char_type * | __s,
|  | streamsize | __n
| ) | `[inline]`

Entry point for xsgetn.

Parameters:

  | s | A buffer area.
  | n | A count.

Returns xsgetn(s,n). The effect is to fill s[0] through s[n-1] with characters from the input sequence, if possible.

Definition at line 332 of file streambuf.

virtual streamsize showmanyc | ( |  | ) | `[inline, protected, virtual]`

Investigating the data available.

Returns:
  An estimate of the number of characters available in the input sequence, or -1.

"If it returns a positive value, then successive calls to `underflow()` will not return `traits::eof()` until at least that number of characters have been supplied. If `showmanyc()` returns -1, then calls to `underflow()` or `uflow()` will fail." [27.5.2.4.3]/1

Note:
  Base class version does nothing, returns zero.

  The standard adds that "the intention is not only that the calls [to underflow or uflow] will not return `eof()` but that they will return "immediately".

  The standard adds that "the morphemes of `showmanyc` are "es-how-many-see", not "show-manic".

Reimplemented in basic_filebuf, and basic_filebuf< char_type, traits_type >.

Definition at line 623 of file streambuf.

Referenced by basic_streambuf< char_type, traits_type >::in_avail().

int_type snextc | ( |  | ) | `[inline]`

Getting the next character.

Returns:
  The next character, or eof.

Calls `sbumpc()`, and if that function returns `traits::eof()`, so does this function. Otherwise, `sgetc()`.

Definition at line 273 of file streambuf.

Referenced by basic_istream::get(), basic_istream::getline(), and basic_istream::ignore().

int_type sputbackc | ( | char_type | __c | ) | `[inline]`

Pushing characters back into the input stream.

Parameters:

  | c | The character to push back.

Returns:
  The previous character, if possible.

Similar to sungetc(), but c is pushed onto the stream instead of "the previous character". If successful, the next character fetched from the input stream will be c.

Definition at line 346 of file streambuf.

Referenced by std::operator>>(), and basic_istream::putback().

int_type sputc | ( | char_type | __c | ) | `[inline]`

Entry point for all single-character output functions.

Parameters:

  | c | A character to output.

Returns:
  c, if possible.

One of two public output functions.

If a write position is available for the output sequence (i.e., the buffer is not full), stores c in that position, increments the position, and returns `traits::to_int_type(c)`. If a write position is not available, returns `overflow(c)`.

Definition at line 398 of file streambuf.

Referenced by basic_istream::get(), ostreambuf_iterator::operator=(), and basic_stringbuf::overflow().

streamsize sputn | ( | const char_type * | __s,
|  | streamsize | __n
| ) | `[inline]`

Entry point for all single-character output functions.

Parameters:

  | s | A buffer read area.
  | n | A count.

One of two public output functions.

Returns xsputn(s,n). The effect is to write s[0] through s[n-1] to the output sequence, if possible.

Definition at line 424 of file streambuf.

void stossc | ( |  | ) | `[inline]`

Tosses a character.

Advances the read pointer, ignoring the character that would have been read.

See http://gcc.gnu.org/ml/libstdc++/2002-05/msg00168.html

Note:
  This function has been deprecated by the standard. You must define `_GLIBCXX_DEPRECATED` to make this visible; see c++config.h.

Definition at line 760 of file streambuf.

int_type sungetc | ( |  | ) | `[inline]`

Moving backwards in the input stream.

Returns:
  The previous character, if possible.

If a putback position is available, this function decrements the input pointer and returns that character. Otherwise, calls and returns pbackfail(). The effect is to "unget" the last character "gotten".

Definition at line 371 of file streambuf.

Referenced by basic_istream::unget().

virtual int sync | ( | void |  | ) | `[inline, protected, virtual]`

Synchronizes the buffer arrays with the controlled sequences.

Returns:
  -1 on failure.

Each derived class provides its own appropriate behavior, including the definition of "failure".

Note:
  Base class version does nothing, returns zero.

Reimplemented in stdio_sync_filebuf, basic_filebuf, and basic_filebuf< char_type, traits_type >.

Definition at line 601 of file streambuf.

virtual int_type uflow | ( |  | ) | `[inline, protected, virtual]`

Fetches more data from the controlled sequence.

Returns:
  The first character from the pending sequence.

Informally, this function does the same thing as `underflow()`, and in fact is required to call that function. It also returns the new character, like `underflow()` does. However, this function also moves the read position forward by one.

Reimplemented in stdio_sync_filebuf.

Definition at line 674 of file streambuf.

Referenced by basic_streambuf< char_type, traits_type >::sbumpc(), basic_streambuf< char_type, traits_type >::stossc(), and basic_streambuf::xsgetn().

virtual int_type underflow | ( |  | ) | `[inline, protected, virtual]`

Fetches more data from the controlled sequence.

Returns:
  The first character from the pending sequence.

Informally, this function is called when the input buffer is exhausted (or does not exist, as buffering need not actually be done). If a buffer exists, it is "refilled". In either case, the next available character is returned, or `traits::eof()` to indicate a null pending sequence.

For a formal definiton of the pending sequence, see a good text such as Langer & Kreft, or [27.5.2.4.3]/7-14.

A functioning input streambuf can be created by overriding only this function (no buffer area will be used). For an example, see http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#6

Note:
  Base class version does nothing, returns eof().

Reimplemented in stdio_sync_filebuf, basic_filebuf, basic_stringbuf, and basic_filebuf< char_type, traits_type >.

Definition at line 661 of file streambuf.

Referenced by basic_streambuf< char_type, traits_type >::sgetc().

streamsize xsgetn | ( | char_type * | __s,
|  | streamsize | __n
| ) | `[protected, virtual]`

Multiple character extraction.

Parameters:

  | s | A buffer area.
  | n | Maximum number of characters to assign.

Returns:
  The number of characters assigned.

Fills s[0] through s[n-1] with characters from the input sequence, as if by `sbumpc()`. Stops when either n characters have been copied, or when `traits::eof()` would be copied.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented in basic_filebuf, and basic_filebuf< char_type, traits_type >.

Definition at line 50 of file streambuf.tcc.

References std::copy(), basic_streambuf::gbump(), std::min(), and basic_streambuf::uflow().

Referenced by basic_streambuf< char_type, traits_type >::sgetn().

streamsize xsputn | ( | const char_type * | __s,
|  | streamsize | __n
| ) | `[protected, virtual]`

Multiple character insertion.

Parameters:

  | s | A buffer area.
  | n | Maximum number of characters to write.

Returns:
  The number of characters written.

Writes s[0] through s[n-1] to the output sequence, as if by `sputc()`. Stops when either n characters have been copied, or when `sputc()` would return `traits::eof()`.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented in basic_filebuf, and basic_filebuf< char_type, traits_type >.

Definition at line 84 of file streambuf.tcc.

References std::copy(), std::min(), basic_streambuf::overflow(), and basic_streambuf::pbump().

Referenced by basic_streambuf< char_type, traits_type >::sputn().

The documentation for this class was generated from the following files:

- streambuf
- streambuf.tcc